;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of IndigoGame
;; Copyright 2018 José Agulló García, David Azuar Alonso, Elza Sarrías Alieva
;;
;; IndigoGame is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; IndigoGame is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with IndigoGame.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.globl aim
.globl bullet_draw
.globl bullet_update
.globl bullet_do_for_all 
.globl clear_all_bullets
.globl bullet_clear_last
.globl bullet_clear_current

.macro DefineBullet _name, _x, _y, _vx, _vy, _last_x, _last_y, _col
_name:
   .db    _x, _y     ;; X, Y
   .db   _vx, _vy     ;; VX, VY
   .db _last_x, _last_y
   .db   _col           ;; Color
    _name'_size = . - _name 
.endm

.macro DefineBulletDefault _name, _suf
    DefineBullet _name'_suf, 0xBB, 0, 0, 0, 0, 0, 0xFF
.endm

.macro DefineNBullets _name, _n 
    _c = 0 
    .rept _n 
        DefineBulletDefault _name, \_c 
        _c = _c + 1 
    .endm
.endm


b_x = 0
b_y = 1
b_vx = 2
b_vy = 3
b_lx = 4
b_ly = 5
b_col = 6

bullet_w = 1
bullet_h = 4