;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of IndigoGame
;; Copyright 2018 José Agulló García, David Azuar Alonso, Elza Sarrías Alieva
;;
;; IndigoGame is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; IndigoGame is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with IndigoGame.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.globl enemy_draw
.globl enemy_move
.globl enemy_add
.globl enemy_clear_last
.globl enemy_clear_current
.globl enemy_do_for_all
.globl delete_if_bullet_colision
.globl get_num_enm
.globl k_max_enm
.globl check_hero_death
.globl remove_all_enemies
.globl get_current_vector 
.globl check_xy_inside_bc_box 

.globl aux_h
.globl aux_w 

k_max_enm = 4

.macro DefineEnemy _name, _x, _y,_last_x, _last_y, _sp, _update, _dead
_name:
    .db _x, _y ;; X, Y
    .db _last_x, _last_y 
    .dw _sp
    .dw _update
    .db _dead
    _name'_size = . - _name
.endm

.macro DefineEnemyDefault _name, _suf
    DefineEnemy _name'_suf, 0xAA,  0, 0, 0,  0x0000, 0x0000, 0x00
.endm

.macro DefineNEnemies _name, _n
    _c = 0
    .rept _n
        DefineEnemyDefault _name, \_c
        _c = _c + 1
    .endm
.endm

.globl enemy_data

enm_x = 0
enm_y = 1
enm_lx = 2
enm_ly = 3 
enm_sp_l = 4
enm_sp_h = 5
enm_upd_l = 6 
enm_upd_h = 7 
enm_dead = 8 

enemy_w = 6
enemy_h = 12

enemy_vx = 1 
enemy_vy = 2 


.globl _skull_sprite_0
.globl _skull_sprite_1
.globl _skull_sprite_2
.globl _skull_sprite_3
.globl _skull_sprite_4
.globl _skull_sprite_5
.globl _skull_sprite_6
.globl _skull_sprite_7
.globl _explosion_sprite