;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of IndigoGame
;; Copyright 2018 José Agulló García, David Azuar Alonso, Elza Sarrías Alieva
;;
;; IndigoGame is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; IndigoGame is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with IndigoGame.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera_functions.h.s"
.include "magic.h.s"
.include "main.h.s"
.include "maps.h.s"

magic_timer_01: 			.db #magic_initial_timer_01
magic_timer_10: 			.db #magic_initial_timer_10
magic_dec_t:	 			.db #magic_dec_timer
need_draw_magic_timer:   .db #2

draw_magic_timer:
   ld    l, #0                   ;; D = Background PEN (0)
   ld    h, #1                   ;; E = Foreground PEN (3)
   call cpct_setDrawCharM0_asm   ;; Set draw char colours

   call print_10
   jp	print_01


print_10:
   ld a, (magic_timer_10) 

   call a_to_char_in_iy

   call get_start_video_memory
   ld   bc, #80 * 22 + 68 + 4*0
   add  hl, bc 
   jp cpct_drawStringM0_asm  ;; Draw the string

print_01:
   ld a, (magic_timer_01)

   call a_to_char_in_iy

   call get_start_video_memory
   ld   bc, #80 * 22 + 68 + 4*1
   add  hl, bc 
   jp cpct_drawStringM0_asm  ;; Draw the string

check_dec_magic_timer:
	ld 	a, (magic_dec_t)
	cp  #0
	jp 	z, dec_magic_timer
		dec a
		ld 	(magic_dec_t), a
		ret

dec_magic_timer:
	call restore_dec_magic_timer
	ld 	a, (magic_timer_01)
	cp 	#0
	jp  z, check_timer_10
		dec a
		ld (magic_timer_01), a
		jp restore_need_draw_magic_timer

check_timer_10:
	ld  a, (magic_timer_10)
	cp  #0
	jp 	z, hero_death
		dec a
		ld 	(magic_timer_10), a
		ld 	a, #9
		ld  (magic_timer_01), a
		jp restore_need_draw_magic_timer

check_need_draw_magic_timer:
   ld  a, (need_draw_magic_timer)
   cp  #0
   ret

dec_need_draw_magic_timer:
   ld    a, (need_draw_magic_timer)
   dec   a
   ld    (need_draw_magic_timer), a
   ret

restore_need_draw_magic_timer:
   ld    a, #2
   ld    (need_draw_magic_timer), a
   ret

reset_magic_timer:
	ld 	a, #magic_initial_timer_10
	ld  (magic_timer_10), a
	ld 	a, #magic_initial_timer_01
	ld  (magic_timer_01), a
	call restore_need_draw_magic_timer
	jp restore_dec_magic_timer

restore_dec_magic_timer:
	ld  a, #magic_dec_timer
	ld  (magic_dec_t), a
	ret