;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of IndigoGame
;; Copyright 2018 José Agulló García, David Azuar Alonso, Elza Sarrías Alieva
;;
;; IndigoGame is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; IndigoGame is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with IndigoGame.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.globl draw_map
.globl map_w_tiles
.globl map_h_tiles
.globl map_initialize
.globl get_current_map_IY
.globl update_current_map
.globl check_can_change_map
.globl get_right_map_HL
.globl get_left_map_HL
.globl get_down_map_HL
.globl get_up_map_HL
.globl check_spawn_current_map
.globl check_map_change
.globl reset_map 
.globl need_draw_score
.globl restore_need_draw_score
.globl dec_need_draw_score
.globl check_need_draw_score

.globl score_string

.globl room_1
.globl room_2
.globl room_3
.globl room_4 
.globl bg_color
.globl score_hero_001
.globl score_hero_010
.globl score_hero_100
.globl draw_score
.globl draw_score_go
.globl reset_score
.globl inc_score_hero
.globl numbers_array
.globl a_to_char_in_iy

.globl win_loop

map_w_tiles = 20
map_h_tiles = 25

bg_color = 0x0F 

.globl initial_spawn_timing
.globl spawn_timing

initial_spawn_timing = 50
spawn_timing = 500

.macro DefineMap _name, _this, _up, _right, _down, _left, _i_stiming, _s_timing
_name:
   .dw   _this       ;; current map
   .dw   _up         ;; up map
   .dw   _right      ;; right map
   .dw   _down       ;; down map
   .dw   _left		 ;; left map
   .db 	 _i_stiming  ;; initial spawn timing
   .db 	 _s_timing 	 ;; spawn timing
.endm

map_this_l  = 0
map_this_h  = 1
map_up_l    = 2
map_up_h    = 3
map_right_l = 4
map_right_h = 5
map_down_l  = 6
map_down_h  = 7
map_left_l  = 8
map_left_h  = 9
map_itiming = 10
map_timing  = 11

.globl map1
.globl map2
.globl map3
.globl map4