;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of IndigoGame
;; Copyright 2018 José Agulló García, David Azuar Alonso, Elza Sarrías Alieva
;;
;; IndigoGame is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; IndigoGame is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with IndigoGame.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "cpctelera_functions.h.s"
.include "video.h.s"
.include "menu.h.s"
.include "assets.h.s"
.include "maps.h.s"
.include "main.h.s"

k_current_option: .db #00

draw_menu:
	call  get_start_video_memory
	push  hl
	ld    bc, #main_menu_size - 1
	add   hl, bc
	ex    de, hl
	ld    hl, #_main_menu + main_menu_size_compressed - 1
	call  cpct_zx7b_decrunch_s_asm
	
	pop   hl
	ld	  bc, #80 * 18 + 20 
	add   hl, bc
	push  hl
	ld 	  a, (k_current_option)
	cp    #00
	jp    nz, no_draw_arrow_0
			call draw_arrow
no_draw_arrow_0:		
	pop   hl
	ld 	  bc, #80 * 3
	add   hl, bc
	ld 	  a, (k_current_option)
	cp    #01
	jp    nz, no_draw_arrow_1
			call draw_arrow
no_draw_arrow_1:
	ret

draw_arrow:
push hl
	ld 	 bc, #-6
	add  hl, bc
	ex   de, hl   		;; DE = Puntero a memoria
	ld   hl, #_arrow
	ld 	 b, #8
	ld 	 c, #4
	call cpct_drawSprite_asm
pop hl
	ret

check_option:
	call  cpct_scanKeyboard_f_asm

	ld    hl, #Key_CursorUp
	call  cpct_isKeyPressed_asm
	jr    z, up_arrow_no_pulsada
		ld 	a, (k_current_option)
		cp 	#00
		jr  nz, dec_current_option
			ld 	a, #01
			ld 	(k_current_option), a
			ret

dec_current_option:
	dec a
	ld 	(k_current_option), a
	ret

up_arrow_no_pulsada:
	ld    hl, #Key_CursorDown
	call  cpct_isKeyPressed_asm
	jr    z, down_arrow_no_pulsada
		ld 	a, (k_current_option)
		cp 	#01
		jr  nz, inc_current_option
			ld 	a, #00
			ld 	(k_current_option), a
			ret

inc_current_option:
	inc a
	ld 	(k_current_option), a
	ret

down_arrow_no_pulsada:
	ld    hl, #Key_Space
	call  cpct_isKeyPressed_asm
	ret   z
		ld 	a, (k_current_option)
		cp  #00
		jp  z, reset_score_main
			jp controls_loop

draw_game_over:
	call  get_start_video_memory
	ld    bc, #game_over_menu_size - 1
	add   hl, bc
	ex    de, hl
	ld    hl, #_game_over_menu + game_over_menu_size_compressed - 1
	jp  cpct_zx7b_decrunch_s_asm


draw_controls:
	call  get_start_video_memory
	ld    bc, #controls_menu_size - 1
	add   hl, bc
	ex    de, hl
	ld    hl, #_controls_menu + controls_menu_size_compressed - 1
	jp  cpct_zx7b_decrunch_s_asm

draw_win:
	call  get_start_video_memory
	ld    bc, #win_menu_size - 1
	add   hl, bc
	ex    de, hl
	ld    hl, #_win_menu + win_menu_size_compressed - 1
	jp  cpct_zx7b_decrunch_s_asm

menu_check_go_back:
	call  cpct_scanKeyboard_f_asm
	ld    hl, #Key_Esc
	call  cpct_isKeyPressed_asm
	jp 	  nz, menu_loop
	ret

menu_check_retry:
	call  cpct_scanKeyboard_f_asm
	ld    hl, #Key_Space
	call  cpct_isKeyPressed_asm
	ret z
	ld de, #_song_ingame
   	call cpct_akp_musicInit_asm
	jp 	  reset_score_main
	ret
