;;-----------------------------LICENSE NOTICE------------------------------------
;; This file is part of IndigoGame
;; Copyright 2018 José Agulló García, David Azuar Alonso, Elza Sarrías Alieva
;;
;; IndigoGame is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; IndigoGame is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with IndigoGame.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "cpctelera_functions.h.s"
.include "bullet.h.s"
.include "hero.h.s"
.include "video.h.s"
.include "enemy.h.s" 
.include "maps.h.s"
.include "token.h.s"


ispresent: .db #00
nmaps: .db #00
erase: .db #00

token_map: .dw #map1
token_x: .db 0x20
token_y: .db 0x20

drawtoken:
    call get_current_map_IY 
	ld d, map_this_h(iy) 
	ld e, map_this_l(iy) ;; en de --> mapa actual 
	ld ix, (token_map) ;; en hl --> ultima mapa guardado 
    ld h, map_this_h(ix)
    ld l, map_this_l(ix)
	or a  
	sbc hl, de 
      jp nz, notpresent

    call get_start_video_memory	;; Comienzo memoria de video
	ex 	 de, hl
	ld a, (token_x)
    ld c, a
	ld a, (token_y)
    ld b, a
	call cpct_getScreenPtr_asm

	ex   de, hl   		;; DE = Puntero a memoria
	ld 	 hl, #_token_sprite
	ld 	 b, #10   	;; alto
	ld 	 c, #5   	;; Ancho

	call cpct_drawSprite_asm

    ld a, #1
    ld (ispresent), a

    jp continue
    
    notpresent:

    ld a, #0
    ld (ispresent), a

    continue:
    ret

spawn:

checkhero:
    ld a, (ispresent)
    cp #0
    ret z


    ;;COMPROBAR COLISION
    ;;;;;;;;;;;;;;;;;;;;;;
    ld a, #hero_w 
    ld (aux_w), a 
    ld a, #hero_h 
    ld (aux_h), a 
    ld b, e_y(ix) 
    ld c, e_x(ix) 
    ld a, (token_x) 
    ld e, a 
    ld a, (token_y)
    ld d, a 
    call check_xy_inside_bc_box
    jp z, hero_takes_token
    ld a, e
    add #5
    ld e, a 
    call check_xy_inside_bc_box
    jp z, hero_takes_token
    ld a, d 
    add #10
    ld d, a 
    call check_xy_inside_bc_box
    jp z, hero_takes_token
    ld a, e
    sub #5 
    ld e, a 
    call check_xy_inside_bc_box
    ret nz 

    ;;;;;;;;;;;;;;;;;;;;;;
    hero_takes_token:

    ld l, #1
	ld h, #15
	ld e, #85
	ld d, #0
	ld b, #0
	ld c, #1
	ld a, #4
    call cpct_akp_SFXPlay_asm

    call reset_magic_timer

    ld a, #2
    ld (erase), a

    ;;CALCULAR NUEVO MAPA
    ;;;;;;;;;;;;;;;;;;;;;;
    jp changetokenmap
    ;;;;;;;;;;;;;;;;;;;;;;

changetokenmap:
    call get_random_map

    setmap0:
    cp   #0
    jr    nz, setmap1
        ld a, #map1
        ld (token_map), a

    setmap1:
    cp   #1
    jr    nz, setmap2
        ld a, #map2
        ld (token_map), a
    setmap2:
    cp   #2
    jr    nz, setmap3
        ld a, #map3
        ld (token_map), a
    setmap3:
    cp   #3
    ret nz
        ld a, #map4
        ld (token_map), a
   ret

get_random_map:
   call cpct_getRandom_mxor_u8_asm
   ld    a, l
   ld    b, #03
   and   b
   ret
    

cleartoken:
    ld a, (erase)
    cp #0
    ret z

    dec a
    ld (erase), a

    call get_start_video_memory
	ex de, hl 

	ld a, (token_x)
    ld c, a
	ld a, (token_y)
    ld b, a
	call cpct_getScreenPtr_asm ;; hl contiene el puntero a la posicion en la memoria en video
	
	ex de, hl ;; de contienen el puntero a la pos

	ld a, #bg_color
	ld b, #10
	ld c, #5
	jp cpct_drawSolidBox_asm